﻿using System;
using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
	public class InductionHypothesis : Rule
	{
		public readonly List<Variable> fixedVars;
		private Nullable<bool> isProved;
		public readonly List<Error>    errors;
		public InductionHypothesis(Coords coords, string name, Equation eq, List<Variable> fixedVars) : base(coords,name,eq)
		{
			this.fixedVars = fixedVars;
			errors = new List<Error>();
		}

		public Nullable<bool> IsProved
		{
			get { return isProved; }
			set { if (isProved == null) isProved = value; else throw new KontextException(coords, "Tried to change existing isProved in Inductionhypothesis!"); }
		}

		public override bool IsFixed(Variable variable) => fixedVars.Contains(variable);
    }
}
