﻿using System;
using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
	public class Proof
	{
		public readonly SingleProof proof;
		public readonly List<Lemma> lemmata;
		public Proof(SingleProof proof, List<Lemma> lemmata)
		{
			this.proof = proof;
			this.lemmata = lemmata;
		}
        public string ToString(bool showMetadata)
        {
			string res = "Proof:\r\n\r\n";
			try
			{
				res += proof.ToString(showMetadata) +"\r\n\r\n";
				foreach (Lemma lemma in lemmata) res += lemma.ToString(showMetadata) +"\r\n\r\n";
			}
			catch (NullReferenceException) { res += "NullReferenceException occured while Proof.ToString."; }
			return res;
        }
    }
}
