﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;
using System.Text;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 43
    /// </summary>
    public class CheckIndHypCanBeUseful : ElementChecker
    {
        /// <summary>
        /// checks error 43
        /// </summary>
        public CheckIndHypCanBeUseful() : base() { }
        public override bool check(Element e)
        {
            if (e is Induction ind)
            {
                List<string> bPVNames = new List<string>();
                foreach (InductionCase ic in ind.indCases)
                    if (ic.BuildingParameterVariables != null)
                        foreach (Variable bPV in ic.BuildingParameterVariables)
                            if (!bPVNames.Contains(bPV.name)) bPVNames.Add(bPV.name);
                bool result = true;
                foreach(InductionHypothesis ih in ind.indHyps)
                {
                    CheckHelper.getSubsAndRenamings(ind.eq, ih.eq, out List<Substitution> subs, out List<Substitution> renamings);
                    if (subs == null) continue;
                    string ihBuildingVarName = "";
                    foreach (Substitution renaming in renamings)
                        if (renaming.tree is TreeVariable tv && renaming.variable == ind.indVar)
                            ihBuildingVarName = tv.name;
                    if (ihBuildingVarName != "")
                        if (!bPVNames.Contains(ihBuildingVarName))
                        { result = false; ih.errors.Add(new Error(43)); }
                }
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
